#include "cplex.h"

#define CPLEX_OK 0
#define ERROR_NO_AVAIABLE_LICENSE -1
#define MY_CPX_TIME_LIMIT  300.0
#define MY_CPX_EPOPT  1e-9
#define MY_CPX_EPRHS  1e-9
#define MY_CPX_BAREPCOMP	1e-9
#define MY_CPX_EPAGAP	1e-8
#define MY_CPX_EPGAP	1e-6
#define MY_CPX_EPMRK 0.0001
#define MY_CPX_EPPER 1e-7
#define MY_CPX_BARMAXCOR  2
#define MY_CPX_EPINT 1e-6

void cleanup(CPXENVptr env, CPXLPptr lp);
// Return CPLEX_OK if everything is OK.
// Returns ERROR_NO_AVAIABLE_LICENSE if no license avaiable
int openEnv(CPXENVptr &env);
void SetPricingMethod(CPXENVptr env, int type);
void CreateCplexProblem(CPXENVptr env,
						CPXLPptr &lp,
						int numcols, int numrows, double *obj,
						int *beg, int *cnt, int *ind, double *val,
						double *lb, double *ub,
						double *row_lb, double *row_ub,
						char *var_type);
void UpdateCplexProblemBounds(CPXENVptr env, CPXLPptr lp, int num, int *idx, double *lb, double *ub);
void UpdateCplexProblemObj(CPXENVptr env, CPXLPptr lp, int cnt, int *indices, double *values);
void UpdateCplexProblemMatrixCoef(CPXENVptr env, CPXLPptr lp, int numcoefs, int *rowlist, int *collist, double *vallist);
double SolveCplexProblem(CPXENVptr env, CPXLPptr lp, double *result_vector, int *solutionType);
double SolveCplexMipProblem(CPXENVptr env, CPXLPptr lp, double *result_vector, int *solutionType, int numcols);

