function [active_reactions] = FindActiveReactions(model,m_pwd)
    Private_DefineParameters;

    [met_num, rxn_num] = size(model.S);    
    model.rowlb = model.b;
    model.rowub = model.b;

    model.exchange_reactions = strmatch('EX_', model.rxns);
    model.lb(model.exchange_reactions) = -EXCHANGE_FLUX_BOUND;

    model.lb(model.lb==-1000) = -FLUX_BOUND;
    model.ub(model.ub==+1000) = FLUX_BOUND;    
    model.c = zeros(rxn_num,1);
    model.c(1) = 1;
    model.int_vars = zeros(rxn_num,1);
    model.rxn_num = rxn_num;
    model.met_num = met_num; 

    batch_lb1 = sparse( [1:rxn_num]', [1:rxn_num]', zeros(rxn_num,1) + 0.01 - model.lb);
    batch_ub1 = sparse( rxn_num, rxn_num );
    
    batch_lb2 = sparse( rxn_num, rxn_num );
    batch_ub2 = sparse( [1:rxn_num]', [1:rxn_num]', zeros(rxn_num,1) - 0.01 - model.ub);
    
    model.batch_lb = [batch_lb1  batch_lb2];
    model.batch_ub = [batch_ub1  batch_ub2];

    model_list{1} = model;
    batch_run = OptBatchRun(model_list, 0, 10000, 1, 'batch_active',m_pwd);
    model_list = OptBatchLoad(model_list, batch_run, 0);
    model = model_list{1};
    
    f = model.result_status(1:rxn_num);
    b = model.result_status((rxn_num+1):end);
    active_reactions = (f==1) | (b==1);
    
    
    
