function [prob_list]= OptBatchLoad(prob_list, batch_run, load_vectors)

    for i=1:length(prob_list)
        
        n = sum(batch_run.data{i}(:,2)); %total number of problems in the batch
        prob_list{i}.result_opt = zeros(n, 1)-1;
        prob_list{i}.result_status = zeros(n, 1)-1;
        
        if (load_vectors == 2)%load only integer vars values
            var_num = size(prob_list{i}.S,2) - prob_list{i}.rxn_num;
            prob_list{i}.result_vector = sparse(n, var_num);
        else
            if (load_vectors == 1)%load values of all vars
                var_num = size(prob_list{i}.lb,1);
                prob_list{i}.result_vector = zeros(n, var_num)-1;
            end
        end
        
        for x=1:size(batch_run.data{i},1)
            p = batch_run.data{i}(x,1);
            s = batch_run.data{i}(x,2);
            result_f = sprintf('%s/prob_%d_result_%d.txt', batch_run.pref, i, p);
            status_f = sprintf('%s/prob_%d_status_%d.txt', batch_run.pref, i, p);
            vector_f = sprintf('%s/prob_%d_vector_%d.txt', batch_run.pref, i, p);
            
            f = fopen(result_f, 'rt');
            if f~=-1
                fclose(f);
                d = load(result_f);
                if size(d,1) == s
                   prob_list{i}.result_opt(p:(p+s-1),1) = d;
                end
            end
            
            f = fopen(status_f, 'rt');
            if f~=-1
                fclose(f);
                d = load(status_f);
                if size(d,1) == s
                   prob_list{i}.result_status(p:(p+s-1),1) = d;
                end
            end

            if (load_vectors ~= 0)
                f = fopen(vector_f, 'rt');
                if f~=-1
                    fclose(f);
                    d = load(vector_f);
                    if (load_vectors == 1)%load all vars values
                        if size(d,1) == s & size(d,2) == var_num
                           prob_list{i}.result_vector(p:(p+s-1),:) = d;
                        end
                    else%load only integer values
                        if size(d,1) == s & size(d,2) == var_num %var_num=num of integer vars, s=number of problems
                            m = repmat(prob_list{i}.wt_bin', size(d,1), 1);
%                             wt_bin_col=prob_list{i}.batch_ko_iteration(p:(p+s-1));
%                             m=(prob_list{i}.wt_bin(:, wt_bin_col))';
                            prob_list{i}.result_vector(p:(p+s-1),:) = d-m; %mark the CHANGE between the integer value in the WT run and this run
                        end
                    end
                end
            end
            
        end
        fprintf('Problem %d: completed = %.3f\n', i, mean(prob_list{i}.result_status~=-1));
    end

