m_pwd='/home/sysbio/natalym/project3/HTM_run';

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%5
%Toy Model
if (1==0)

model=0;
model.S = sparse(9, 12);
model.S([1], 1) = 1;
model.S([1;4], 2) = [-1;1];
model.S([3;4;7;8], 3) = [-1;-1;1;1];
model.S([7], 4) = [-1];
model.S([8], 5) = [-1];
model.S([2], 6) = [1];
model.S([1;2;5;6], 7) = [-1;-1;1;1];
model.S([6;9], 8) = [-1;1];
model.S([9], 9) = [-1];
model.S([3], 10) = [1];
model.S([5], 11) = [-1];
model.S([1;4], 12) = [-1;1];
model.lb = [-10;-10;0;-10;0;-10;0;0;-10;0;0;-10];
model.ub = [10;10;10;10;10;10;10;10;10;10;10;10];
model.b = [0;0;0;0;0;0;0;0;0];
model.rules = cell(12,1);
model.rules{1} = 'x(1) | x(2)';
model.rules{3} = 'x(3)';
model.rules{5} = 'x(4)';
model.rules{6} = 'x(5)';
model.rules{7} = 'x(6)';
model.rules{8} = 'x(7)';
model.genes = {'G1'; 'G2'; 'G3'; 'G4'; 'G5'; 'G6'; 'G7'}; 
model.genes_unique_names = {'G1'; 'G2'; 'G3'; 'G4'; 'G5'; 'G6'; 'G7'}; 
model.rxns = {'R1'; 'R2'; 'R3'; 'R4'; 'R5'; 'R6'; 'R7'; 'R8'; 'R9'; 'R10'; 'R11'; 'R12'}; 
model.mets = {'M1'; 'M2'; 'M3'; 'M4'; 'M5'; 'M6'; 'M7'; 'M8'; 'M9'};
model.rxnGeneMat = sparse(12, 7);
model.rxnGeneMat(1, [1,2]) = 1;
model.rxnGeneMat(3, [3]) = 1;
model.rxnGeneMat(5, [4]) = 1;
model.rxnGeneMat(6, [5]) = 1;
model.rxnGeneMat(7, [6]) = 1;
model.rxnGeneMat(8, [7]) = 1;
model.subSystems = {'Sub1'; 'Sub1'; 'Sub1'; 'Sub1'; 'Sub1'; 'Sub1'; 'Sub1'; 'Sub1'; 'Sub1'; 'Sub1'; 'Sub1'; 'Sub1'};
model.rxnNames = {'R1'; 'R2'; 'R3'; 'R4'; 'R5'; 'R6'; 'R7'; 'R8'; 'R9'; 'R10'; 'R11'; 'R12'}; 
[model.genes_unique t model.genes_unique_map] = unique(model.genes);

exp_data = [1;1;1;0;-1;-1;1];
model_list = cell(0);
model_list{1} = ProcessModelExp(model, exp_data, [], 'test');

genes = [1;1;1;1;1;1;1];
reactions_activity = [1;1;1;1;1;1;1;1;1;1;1;1];
reactions_direction = [1;1;1;1;1;1;1;1;1;1;1;1];
[model_list batch_run] = CBM_Exp_Run(model_list, genes, reactions_activity, reactions_direction, 100, 1, 'batch2',m_pwd);
%call condor - IN THIS PART WE MANUALLY RUN CPLEX THROUGH UNIX AND ONLY
%AFTER THAT WAS FINISHED (USUALLY TOOK A FEW HOURS OR EVEN A DAY - DEPNADS ON THE BATCH SIZE )
[model_list] = CBM_Exp_Load(model_list, batch_run);

end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%5

%SECOND TOY MODEL


%AN EXAMPLE THAT DOES NOT USE INTEGER VARS
if (1==0)
    prob1.S = [1 1 0; 0 1 1];
    prob1.rowlb = [0;2];
    prob1.rowub = [5;7];
    prob1.c = [1;2;3];
    prob1.int_vars = [0;0;0];
    prob1.lb = [0;0;0];
    prob1.ub = [2;2;2];

    prob1.batch_lb = sparse(3, 100);
    prob1.batch_ub = sparse(3, 100);
    prob1.batch_lb(3,:) = rand(1,100)*2;
    prob1.batch_ub(3,:) = prob1.batch_lb(3,:) + rand(1,100);

    prob1.batch_lb = round(prob1.batch_lb*100)/100;
    prob1.batch_ub = round(prob1.batch_ub*100)/100;

    prob2=prob1;
    prob2.c = [2;2;1];

    prob_list{1} = prob1;
    prob_list{2} = prob2;

    [batch_run]= OptBatchRun(prob_list, 1, 5, 3, 'batch1');
    %RUN CPLEX BY YOURSELF ON THE SYSTEM (MAY TAKE A FEW HOURS)
    prob_list = OptBatchLoad(prob_list, batch_run);
    return;
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%5
%RUNNING OUR MODEL - WITH THE ADDITION OF EXPRESSION CONSTRAINTS (BOLLEAN VARS)

if (1==0)
    load humanModel;
    model.active_reactions = FindActiveReactions(model);
    return;
end


if (1==0)
    load model;
    model.rules{3143} = '(x(1826)) | (x(284)) | (x(1719)) | (x(288)) | (x(287)) | (x(285)) | (x(1718)) | (x(1722)) | (x(283)) | (x(287)) | (x(1721)) | (x(1720)) | (x(284)) | (x(1723)) | (x(290))';
    model.genes_unique_names = textread('model_genes_names.txt', '%s');
    model.ec = textread('EC_numbers.txt', '%s');
    
    for i=1:length(model.genes)
        p = strfind(model.genes{i}, '.');
        model.genes2{i,1} = model.genes{i}(1:p-1);
    end

    [model.genes_unique t model.genes_unique_map] = unique(model.genes2);
    if (1==0)
        f=fopen('model_genes_ids.txt', 'wt'); 
        for i=1:length(model.genes_unique) 
            fprintf(f, '%s\n', model.genes_unique{i}); 
        end;
        fclose(f); 
    end

    LoadExp;%LOAD EXPRESSION DATA

    model_list = cell(0);
    %CALL THE FUNCTION THAT TAKES THE EXPRESSION DATA AND ADDS INTEGER VARS
    %AND NEW CONSTARINTS THAT BIND THE FLUX AND EXPRESSION STATE
    model_list{1} = ProcessModelExp(model, exp.liver_embryo, []);
       
    %
    %calc score for all genes and reactions
    genes = zeros(model_list{1}.gene_num, 1)+1;
    reactions_activity = zeros(model_list{1}.rxn_num, 1)+1;
    
     %for exchange reaction calc scores for both directions 
    reactions_direction = zeros(model_list{1}.rxn_num, 1);
    v = strmatch('EX_', model_list{1}.rxns);
    reactions_direction(v) = 1;

    [model_list batch_run] = CBM_Exp_Run(model_list, genes, reactions_activity, reactions_direction, 300, 7, 'batch30');
    %RUN CPLEX BY YOURSELF ON THE SYSTEM (MAY TAKE A FEW HOURS)
    [model_list] = CBM_Exp_Load(model_list, batch_run);

    return;
end



